"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLog = exports.getWebUIUpdates = exports.getServerInfo = exports.getPlayersLocation = exports.getPlayerList = exports.getPlayerInventories = exports.getPlayerInventory = exports.getLandClaims = exports.getHostileLocation = exports.getAnimalsLocation = exports.executeConsoleCommand = exports.getAllowedCommands = exports.getOnlinePlayers = exports.getStats = exports.getBaseUrl = void 0;
var node_fetch_1 = require("node-fetch");
var qs_1 = require("qs");
var handleSteamId_1 = require("./handleSteamId");
function getBaseUrl(server) {
    var scheme = "http";
    var needsPort = true;
    if (server.forceHttps === true) {
        scheme = "https";
    }
    else if (server.forceHttps === false) {
        scheme = "http";
    }
    else if (parseInt(server.port) === 443) {
        needsPort = false;
        scheme = "https";
    }
    else if (parseInt(server.port) === 80) {
        needsPort = false;
        scheme = "http";
    }
    return needsPort ? scheme + "://" + server.ip + ":" + server.port : scheme + "://" + server.ip;
}
exports.getBaseUrl = getBaseUrl;
function fetchJson(server, url, qs, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        var uri;
        return __generator(this, function (_a) {
            uri = getBaseUrl(server) + url + '?' + qs_1.stringify(qs, { skipNulls: true });
            return [2 /*return*/, node_fetch_1.default(uri, fetchOpts)
                    .then(function (response) {
                    if (!response.ok) {
                        throw Error(response.statusText);
                    }
                    return response;
                }).then(function (response) {
                    var contentType = response.headers.get("content-type");
                    if (contentType && contentType.indexOf("application/json") !== -1) {
                        return response.json().then(handleSteamId_1.handleSteamId);
                    }
                    else {
                        return response.text();
                    }
                })];
        });
    });
}
function getStats(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getstats", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getStats = getStats;
function getOnlinePlayers(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getplayersonline", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getOnlinePlayers = getOnlinePlayers;
function getAllowedCommands(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getallowedcommands", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getAllowedCommands = getAllowedCommands;
function executeConsoleCommand(server, command, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/executeconsolecommand", { adminuser: server.adminUser, admintoken: server.adminToken, command: command }, fetchOpts)];
        });
    });
}
exports.executeConsoleCommand = executeConsoleCommand;
function getAnimalsLocation(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getanimalslocation", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getAnimalsLocation = getAnimalsLocation;
function getHostileLocation(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/gethostilelocation", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getHostileLocation = getHostileLocation;
function getLandClaims(server, steamId, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getlandclaims", { adminuser: server.adminUser, admintoken: server.adminToken, steamid: steamId }, fetchOpts)];
        });
    });
}
exports.getLandClaims = getLandClaims;
function getPlayerInventory(server, steamId, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getplayerinventory", { adminuser: server.adminUser, admintoken: server.adminToken, steamid: steamId, userid: "Steam_" + steamId }, fetchOpts)];
        });
    });
}
exports.getPlayerInventory = getPlayerInventory;
function getPlayerInventories(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getplayerinventories", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getPlayerInventories = getPlayerInventories;
function getPlayerList(server, rowsPerPage, page, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getplayerlist", { adminuser: server.adminUser, admintoken: server.adminToken, rowsperpage: rowsPerPage, page: page }, fetchOpts)];
        });
    });
}
exports.getPlayerList = getPlayerList;
function getPlayersLocation(server, offline, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getplayerslocation", { adminuser: server.adminUser, admintoken: server.adminToken, offline: offline }, fetchOpts)];
        });
    });
}
exports.getPlayersLocation = getPlayersLocation;
function getServerInfo(server, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getserverinfo", { adminuser: server.adminUser, admintoken: server.adminToken }, fetchOpts)];
        });
    });
}
exports.getServerInfo = getServerInfo;
function getWebUIUpdates(server, latestLine, fetchOpts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getwebuiupdates", { adminuser: server.adminUser, admintoken: server.adminToken, latestLine: latestLine }, fetchOpts)];
        });
    });
}
exports.getWebUIUpdates = getWebUIUpdates;
function getLog(server, firstLine, count, fetchOpts) {
    if (count === void 0) { count = 50; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchJson(server, "/api/getlog", { adminuser: server.adminUser, admintoken: server.adminToken, firstLine: firstLine, count: count }, fetchOpts)];
        });
    });
}
exports.getLog = getLog;
//# sourceMappingURL=index.js.map